<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: matrix_la_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_571b715927b0d4b7bee37d60dac387ec.html">matrix</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">matrix_la_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2009  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_MATRIx_LA_FUNCTS_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_MATRIx_LA_FUNCTS_ABSTRACT_ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;matrix_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;complex&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//                             Global linear algebra functions </span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keyword">const</span> matrix_exp::matrix_type inv (</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    );</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">const</span> matrix pinv (</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordtype">double</span> tol = 0</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    );</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">void</span> svd (</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; u,</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; w,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; v</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    );</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">long</span> svd2 (</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordtype">bool</span> withu, </div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordtype">bool</span> withv, </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; u,</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; w,</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; v</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    );</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordtype">void</span> svd3 (</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; u,</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; w,</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        matrix&lt;matrix_exp::type&gt;&amp; v</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    );</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        &gt;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keywordtype">void</span> svd_fast (</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keyword">const</span> matrix&lt;T&gt;&amp; A,</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        matrix&lt;T&gt;&amp; u,</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        matrix&lt;T&gt;&amp; w,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        matrix&lt;T&gt;&amp; v,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> l,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> q = 1</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    );</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">typename</span> sparse_vector_type, </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        &gt;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordtype">void</span> svd_fast (</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keyword">const</span> std::vector&lt;sparse_vector_type&gt;&amp; A,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        matrix&lt;T&gt;&amp; u,</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        matrix&lt;T&gt;&amp; w,</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        matrix&lt;T&gt;&amp; v,</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> l,</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> q = 1</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    );</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160; </div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        <span class="keywordtype">long</span> NR,</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordtype">long</span> NC,</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keyword">typename</span> MM,</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        &gt;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keywordtype">void</span> orthogonalize (</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; m</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    );</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160; </div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keyword">const</span> matrix real_eigenvalues (</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    );</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160; </div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> det (</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    );</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160; </div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> trace (</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    );</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keyword">const</span> matrix_exp::matrix_type chol (</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; A</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    );</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160; </div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <span class="keyword">const</span> matrix_exp::matrix_type inv_lower_triangular (</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; A</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    );</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160; </div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keyword">const</span> matrix_exp::matrix_type inv_upper_triangular (</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; A</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    );</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;<span class="comment">//                             Matrix decomposition classes </span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160; </div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;        <span class="keyword">typename</span> matrix_exp_type</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        &gt;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    <span class="keyword">class </span>lu_decomposition</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    {</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160; </div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NR = matrix_exp_type::NR;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NC = matrix_exp_type::NC;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::type type;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::layout_type layout_type;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160; </div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;        <span class="keyword">typedef</span> matrix&lt;type,0,0,mem_manager_type,layout_type&gt;  matrix_type;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        <span class="keyword">typedef</span> matrix&lt;type,NR,1,mem_manager_type,layout_type&gt; column_vector_type;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        <span class="keyword">typedef</span> matrix&lt;long,NR,1,mem_manager_type,layout_type&gt; pivot_column_vector_type;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160; </div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        lu_decomposition (</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt; &amp;A</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        );</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        <span class="keywordtype">bool</span> is_square (</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;        <span class="keywordtype">bool</span> is_singular (</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        <span class="keywordtype">long</span> nr(</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;        <span class="keywordtype">long</span> nc(</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;        <span class="keyword">const</span> matrix_type get_l (</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;        <span class="keyword">const</span> matrix_type get_u (</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keyword">const</span> pivot_column_vector_type&amp; get_pivot (</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;        type det (</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        <span class="keyword">const</span> matrix_type solve (</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt; &amp;B</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    }; </div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160; </div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160; </div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;        <span class="keyword">typename</span> matrix_exp_type</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;        &gt;</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;    <span class="keyword">class </span>cholesky_decomposition</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    {</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160; </div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NR = matrix_exp_type::NR;</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NC = matrix_exp_type::NC;</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::type type;</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::layout_type layout_type;</div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160; </div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::matrix_type matrix_type;</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;        <span class="keyword">typedef</span> matrix&lt;type,NR,1,mem_manager_type,layout_type&gt; column_vector_type;</div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160; </div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;        cholesky_decomposition(</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; A</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;        );</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;        <span class="keywordtype">bool</span> is_spd(</div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;        <span class="keyword">const</span> matrix_type&amp; get_l(</div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;        <span class="keyword">const</span> matrix solve (</div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; B</div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;    };</div><div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160; </div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160; </div><div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;        <span class="keyword">typename</span> matrix_exp_type</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;        &gt;</div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;    <span class="keyword">class </span>qr_decomposition </div><div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;    {</div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160; </div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NR = matrix_exp_type::NR;</div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NC = matrix_exp_type::NC;</div><div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::type type;</div><div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::layout_type layout_type;</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160; </div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;        <span class="keyword">typedef</span> matrix&lt;type,0,0,mem_manager_type,layout_type&gt; matrix_type;</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160; </div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;        qr_decomposition(</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; A</div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;        );</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;        <span class="keywordtype">bool</span> is_full_rank(</div><div class="line"><a name="l00682"></a><span class="lineno">  682</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;        <span class="keywordtype">long</span> nr(</div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00698"></a><span class="lineno">  698</span>&#160;        <span class="keywordtype">long</span> nc(</div><div class="line"><a name="l00699"></a><span class="lineno">  699</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;        <span class="keyword">const</span> matrix_type get_r (</div><div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;        <span class="keyword">const</span> matrix_type get_q (</div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;        <span class="keywordtype">void</span> get_q (</div><div class="line"><a name="l00730"></a><span class="lineno">  730</span>&#160;            matrix_type&amp; Q</div><div class="line"><a name="l00731"></a><span class="lineno">  731</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00739"></a><span class="lineno">  739</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;        <span class="keyword">const</span> matrix_type solve (</div><div class="line"><a name="l00741"></a><span class="lineno">  741</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; B</div><div class="line"><a name="l00742"></a><span class="lineno">  742</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00759"></a><span class="lineno">  759</span>&#160;    };</div><div class="line"><a name="l00760"></a><span class="lineno">  760</span>&#160; </div><div class="line"><a name="l00761"></a><span class="lineno">  761</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00762"></a><span class="lineno">  762</span>&#160; </div><div class="line"><a name="l00763"></a><span class="lineno">  763</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00764"></a><span class="lineno">  764</span>&#160;        <span class="keyword">typename</span> matrix_exp_type</div><div class="line"><a name="l00765"></a><span class="lineno">  765</span>&#160;        &gt;</div><div class="line"><a name="l00766"></a><span class="lineno">  766</span>&#160;    <span class="keyword">class </span>eigenvalue_decomposition</div><div class="line"><a name="l00767"></a><span class="lineno">  767</span>&#160;    {</div><div class="line"><a name="l00814"></a><span class="lineno">  814</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00815"></a><span class="lineno">  815</span>&#160; </div><div class="line"><a name="l00816"></a><span class="lineno">  816</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NR = matrix_exp_type::NR;</div><div class="line"><a name="l00817"></a><span class="lineno">  817</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NC = matrix_exp_type::NC;</div><div class="line"><a name="l00818"></a><span class="lineno">  818</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::type type;</div><div class="line"><a name="l00819"></a><span class="lineno">  819</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00820"></a><span class="lineno">  820</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::layout_type layout_type;</div><div class="line"><a name="l00821"></a><span class="lineno">  821</span>&#160; </div><div class="line"><a name="l00822"></a><span class="lineno">  822</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::matrix_type matrix_type;</div><div class="line"><a name="l00823"></a><span class="lineno">  823</span>&#160;        <span class="keyword">typedef</span> matrix&lt;type,NR,1,mem_manager_type,layout_type&gt; column_vector_type;</div><div class="line"><a name="l00824"></a><span class="lineno">  824</span>&#160; </div><div class="line"><a name="l00825"></a><span class="lineno">  825</span>&#160;        <span class="keyword">typedef</span> matrix&lt;std::complex&lt;type&gt;,0,0,mem_manager_type,layout_type&gt; complex_matrix_type;</div><div class="line"><a name="l00826"></a><span class="lineno">  826</span>&#160;        <span class="keyword">typedef</span> matrix&lt;std::complex&lt;type&gt;,NR,1,mem_manager_type,layout_type&gt; complex_column_vector_type;</div><div class="line"><a name="l00827"></a><span class="lineno">  827</span>&#160; </div><div class="line"><a name="l00828"></a><span class="lineno">  828</span>&#160; </div><div class="line"><a name="l00829"></a><span class="lineno">  829</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00830"></a><span class="lineno">  830</span>&#160;        eigenvalue_decomposition(</div><div class="line"><a name="l00831"></a><span class="lineno">  831</span>&#160;            <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; A</div><div class="line"><a name="l00832"></a><span class="lineno">  832</span>&#160;        ); </div><div class="line"><a name="l00845"></a><span class="lineno">  845</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00846"></a><span class="lineno">  846</span>&#160;        eigenvalue_decomposition(</div><div class="line"><a name="l00847"></a><span class="lineno">  847</span>&#160;            <span class="keyword">const</span> matrix_op&lt;op_make_symmetric&lt;EXP&gt; &gt;&amp; A</div><div class="line"><a name="l00848"></a><span class="lineno">  848</span>&#160;        ); </div><div class="line"><a name="l00874"></a><span class="lineno">  874</span>&#160;        <span class="keywordtype">long</span> dim (</div><div class="line"><a name="l00875"></a><span class="lineno">  875</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00881"></a><span class="lineno">  881</span>&#160;        <span class="keyword">const</span> complex_column_vector_type get_eigenvalues (</div><div class="line"><a name="l00882"></a><span class="lineno">  882</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00892"></a><span class="lineno">  892</span>&#160;        <span class="keyword">const</span> column_vector_type&amp; get_real_eigenvalues (</div><div class="line"><a name="l00893"></a><span class="lineno">  893</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00902"></a><span class="lineno">  902</span>&#160;        <span class="keyword">const</span> column_vector_type&amp; get_imag_eigenvalues (</div><div class="line"><a name="l00903"></a><span class="lineno">  903</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00912"></a><span class="lineno">  912</span>&#160;        <span class="keyword">const</span> complex_matrix_type get_v (</div><div class="line"><a name="l00913"></a><span class="lineno">  913</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00922"></a><span class="lineno">  922</span>&#160;        <span class="keyword">const</span> complex_matrix_type get_d (</div><div class="line"><a name="l00923"></a><span class="lineno">  923</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00934"></a><span class="lineno">  934</span>&#160;        <span class="keyword">const</span> matrix_type&amp; get_pseudo_v (</div><div class="line"><a name="l00935"></a><span class="lineno">  935</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00950"></a><span class="lineno">  950</span>&#160;        <span class="keyword">const</span> matrix_type get_pseudo_d (</div><div class="line"><a name="l00951"></a><span class="lineno">  951</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00983"></a><span class="lineno">  983</span>&#160;    };</div><div class="line"><a name="l00984"></a><span class="lineno">  984</span>&#160; </div><div class="line"><a name="l00985"></a><span class="lineno">  985</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00986"></a><span class="lineno">  986</span>&#160; </div><div class="line"><a name="l00987"></a><span class="lineno">  987</span>&#160;}</div><div class="line"><a name="l00988"></a><span class="lineno">  988</span>&#160; </div><div class="line"><a name="l00989"></a><span class="lineno">  989</span>&#160;<span class="preprocessor">#endif // DLIB_MATRIx_LA_FUNCTS_ABSTRACT_</span></div><div class="line"><a name="l00990"></a><span class="lineno">  990</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1matrix__exp_html_a039e80e9a67ddd1abaa4a1004dab7254"><div class="ttname"><a href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">dlib::matrix_exp::type</a></div><div class="ttdeci">matrix_traits&lt; EXP &gt;::type type</div><div class="ttdef"><b>Definition:</b> matrix_exp.h:126</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
